#include "cbw.h"

/* variables pour la librairie universelle (definies dans main.c) */
extern const float RevNum;
extern const int CNA_BoardNum;
extern float DLLRevNum;
extern float VXDRevNum;

HANDLE AlloueTemponMemoire( long NbrVoies )
{
	/* Allocation mmoire pour la Conversion Num->Ana
      simultane de 4 voies */
   return cbWinBufAlloc( NbrVoies );
}

BOOL EcrireTension( HANDLE temponmemoire, double tensionaa, double tensiongd )
{
	unsigned short donnees[4];
	int taux = 330000;

	/* Calcul des tensions  ecrire en sortie des 4 CNA */
	donnees[0] = (unsigned short)( 2048.0 + ( tensiongd ) * 409.6 );
	donnees[1] = (unsigned short)( 2048.0 + ( 5.0 - tensiongd ) * 409.6 );
	donnees[2] = (unsigned short)( 2048.0 + ( 5.0 - tensionaa ) * 409.6 );
	donnees[3] = (unsigned short)( 2048.0 + ( tensionaa ) * 409.6 );

	/* Copie des donnes dans le buffer mmoire */
	if( cbWinArrayToBuf( donnees, temponmemoire, 0L, 4L ) == 0 )
	{
   		/* ecriture en sortie des CNAs simultane*/
		if( cbAOutScan( CNA_BoardNum, 0, 3, 4, &taux, 0, temponmemoire, SIMULTANEOUS ) == 0 )
      		return TRUE;
		else
      		return FALSE;
	}
	else
   		return FALSE;
}

BOOL DesalloueTemponMemoire( HANDLE temponmemoire )
{
	/* Desallocation mmoire pour la C.N->A simultane */
	if( cbWinBufFree( temponmemoire ) == 0 )
		return TRUE;
	else
		return FALSE;
}

