#include <stdio.h>
#include <windows.h>
#include <vfw.h>
#include "vahm32.h"
#include "main.h"

/* variables pour la vision (video for windows) */
extern HWND g_hCapture; /* Handle de la fentre d'acquisition */
extern CAPDRIVERCAPS g_sDriverCaps; /* Caractristique du periph. d'acq. vido */
extern unsigned int g_uiIDDriverVideo; /* Identificateur du periph d'acq. vido */
extern BITMAPINFO g_bmiImage; /* Informations sur l'image acquise, taille, nbpp, ...*/
extern BYTE *g_bImage; /* Image en niveau de gris */

char g_achBuffer[100]; /* Buffer pour l'affichage d texte */

/*****************************************************************************
 * Procdure excute lorsqu'un fonction de VFW32.DLL  choue
 *****************************************************************************/
LRESULT CALLBACK ErreurCallbackProc( HWND hwnd, int nErrID, LPSTR lpErrorText ) 
{ 
    if (nErrID == 0)              // Starting a new major function. 
        return (LRESULT)( TRUE ); // Clear out old errors. 
 
    // Show the error identifier and text. 
    wsprintf( g_achBuffer, "Erreur# %d", nErrID); 
 
    MessageBox(hwnd, lpErrorText, g_achBuffer, 
        MB_OK | MB_ICONEXCLAMATION); 
 
    return (LRESULT)( TRUE ); 
} 

/*****************************************************************************
 * Procdure excute lors d'une acquisition vido
 *****************************************************************************/
LRESULT CALLBACK VideoCallbackProc( HWND hwnd, LPVIDEOHDR lpVHdr )
{
	long i, j;
	long idxMem, idxImage;
	
	for( i = 0; i < g_bmiImage.bmiHeader.biHeight; i++ )
		for( j = 0; j < g_bmiImage.bmiHeader.biWidth; j++ )
		{	
			idxImage = i * g_bmiImage.bmiHeader.biWidth + j;
			idxMem = ( ( g_bmiImage.bmiHeader.biHeight - 1 - i ) * g_bmiImage.bmiHeader.biWidth + 
					   ( j ) ) * 
				( g_bmiImage.bmiHeader.biBitCount / 8 );
			g_bImage[ idxImage ] = (BYTE)RGB( ( lpVHdr->lpData[ idxMem ] ), ( lpVHdr->lpData[ idxMem + 1 ] ), ( lpVHdr->lpData[ idxMem + 2 ] ) ) ;
		}
	return (LRESULT)( TRUE );
}

